QGIS Application - Bug report #14119
Ensure the OGC filter XML expression contains the GML namespace references.
2016-01-16 04:18 PM - Jeremy Palmer

Status: Closed

Priority: Normal

Assignee:

Category: Web Services clients/WFS

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 22121
Description

WFS Servers such as Geoserver won't parse the C XML filter unless it's there. Example expression that fails:

QGIS Expression: "intersects($geometry, geom_from_wkt('POLYGON)"))"

Gets converted to:

OGC XML:
<ogc:Filter xmiIns:ogc="http://www.opengis.net/ogc xmins:gml=http://www.opengis.net/ogc">
<ogc:Intersects>
<ogc:PropertyName>geometry</ogc:PropertyName>
<gml:Polygon>
<gml:outerBoundaryls>
<gml:LinearRing>
<gml:coordinates cs="," ts="">171.9043399999999906,-43.2101120000000023
172.32836199999999849,-43.2101120000000023 172.32836199999999849,-42.99926099999999707
171.9043399999999906,-42.99926099999999707 171.9043399999999906,-43.2101120000000023</gml:coordinates>
</gml:LinearRing>
</gml:outerBoundaryls>
</gml:Polygon>
</ogc:Intersects>
</ogc:Filter>

To fix this the expression to OGC XML function should add the xmins:gml=http://www.opengis.net/ogc namespace. e.g

<ogc:Filter xmIns:ogc="http://www.opengis.net/ogc xmins:gml="http://www.opengis.net/ogc">
<ogc:Intersects>
<ogc:PropertyName>geometry</ogc:PropertyName>
<gml:Polygon>
<gml:outerBoundaryls>
<gml:LinearRing>
<gml:coordinates cs="," ts=" ">171.9043399999999906,-43.2101120000000023
172.32836199999999849,-43.2101120000000023 172.32836199999999849,-42.99926099999999707
171.9043399999999906,-42.99926099999999707 171.9043399999999906,-43.2101120000000023</gml:coordinates>
</gml:LinearRing>
</gml:outerBoundaryls>
</gml:Polygon>
</ogc:Intersects>
</ogc:Filter>
Associated revisions

Revision 9fe6a9fe - 2016-04-05 09:49 PM - Even Rouault

QgsOgcUtils: add support to generate WFS 1.1 and 2.0 filters

Fixes #14119: Ensure the OGC filter XML expression contains the GML namespace references

Revision 8fe0c177 - 2016-09-30 02:23 PM - Even Rouault

QgsOgcUtils: add support to generate WFS 1.1 and 2.0 filters

Fixes #14119: Ensure the OGC filter XML expression contains the GML namespace references

History

#1 - 2016-04-07 01:18 AM - Even Rouault
- Status changed from Open to Closed

Fixed in changeset commit:"9fe6a9fe48059ea10a74128a4fbf57cfa39795ce".
